author | wimpie <wimpie> | 2004-04-02 16:49:47 (UTC) |
---|---|---|
committer | wimpie <wimpie> | 2004-04-02 16:49:47 (UTC) |
commit | 9e26c10c0dc97a0956d019166caf712955094764 (patch) (unidiff) | |
tree | 9bf4f33bd02185780070e178d25e24bdff4d6cd2 /scripts | |
parent | 2f2d702e37cc391dd547eaa7e2432d86285e546d (diff) | |
download | opie-9e26c10c0dc97a0956d019166caf712955094764.zip opie-9e26c10c0dc97a0956d019166caf712955094764.tar.gz opie-9e26c10c0dc97a0956d019166caf712955094764.tar.bz2 |
ipkg-build mkipkg : speedup (avoid grepping over controlfile by loading into array)
SpeciapMTFiles tothreaded : convert control files to -mt.control
-rw-r--r-- | scripts/SpecialMTFiles | 14 | ||||
-rwxr-xr-x | scripts/ipkg-build | 55 | ||||
-rwxr-xr-x | scripts/mkipkg | 22 | ||||
-rwxr-xr-x | scripts/tothreaded | 132 |
4 files changed, 205 insertions, 18 deletions
diff --git a/scripts/SpecialMTFiles b/scripts/SpecialMTFiles new file mode 100644 index 0000000..456550c --- a/dev/null +++ b/scripts/SpecialMTFiles | |||
@@ -0,0 +1,14 @@ | |||
1 | ConvertSpecialFiles() { | ||
2 | local f | ||
3 | for f in "$*" | ||
4 | do | ||
5 | case "$f" in | ||
6 | *libqte*) | ||
7 | echo ${f//qte/qte-mt} | ||
8 | ;; | ||
9 | *) | ||
10 | echo $f | ||
11 | ;; | ||
12 | esac | ||
13 | done | ||
14 | } | ||
diff --git a/scripts/ipkg-build b/scripts/ipkg-build index c6af056..b661bbf 100755 --- a/scripts/ipkg-build +++ b/scripts/ipkg-build | |||
@@ -5,22 +5,57 @@ | |||
5 | # based on a script by Steve Redler IV, steve@sr-tech.com 5-21-2001 | 5 | # based on a script by Steve Redler IV, steve@sr-tech.com 5-21-2001 |
6 | set -e | 6 | set -e |
7 | 7 | ||
8 | ipkg_extract_value() { | 8 | #declare array for values and fields found in control file |
9 | sed -e "s/^[^:]*:[[:space:]]*//" | 9 | declare -a AllValues AllFields |
10 | |||
11 | collect_values() { | ||
12 | local i line | ||
13 | |||
14 | i=0 | ||
15 | while read line | ||
16 | do | ||
17 | AllFields[$i]=${line%%:*} | ||
18 | AllValues[$i]=`echo ${line#*:}` # echo to remove spaces | ||
19 | let i=i+1 | ||
20 | done < ${pkg_dir}/${CONTROL}/control | ||
10 | } | 21 | } |
11 | 22 | ||
12 | required_field() { | 23 | required_field() { |
24 | local field i | ||
13 | field=$1 | 25 | field=$1 |
14 | 26 | ||
15 | value=`grep "^$field:" < $CONTROL/control | ipkg_extract_value` | 27 | i=0 |
16 | if [ -z "$value" ]; then | 28 | for af in "${AllFields[@]}" |
29 | do | ||
30 | if [ "$field" = "$af" ] | ||
31 | then | ||
32 | # return value | ||
33 | echo "${AllValues[$i]}" | ||
34 | return 0; | ||
35 | fi | ||
36 | let i=i+1 | ||
37 | done | ||
38 | # not found | ||
17 | echo "*** Error: $CONTROL/control is missing field $field" >&2 | 39 | echo "*** Error: $CONTROL/control is missing field $field" >&2 |
18 | return 1 | 40 | return 1 |
19 | fi | ||
20 | echo $value | ||
21 | return 0 | ||
22 | } | 41 | } |
23 | 42 | ||
43 | #ipkg_extract_value() { | ||
44 | #sed -e "s/^[^:]*:[[:space:]]*//" | ||
45 | #} | ||
46 | # | ||
47 | #required_field() { | ||
48 | #field=$1 | ||
49 | # | ||
50 | #value=`grep "^$field:" < $CONTROL/control | ipkg_extract_value` | ||
51 | #if [ -z "$value" ]; then | ||
52 | # echo "*** Error: $CONTROL/control is missing field $field" >&2 | ||
53 | # return 1 | ||
54 | #fi | ||
55 | #echo $value | ||
56 | #return 0 | ||
57 | #} | ||
58 | |||
24 | pkg_appears_sane() { | 59 | pkg_appears_sane() { |
25 | local pkg_dir=$1 | 60 | local pkg_dir=$1 |
26 | 61 | ||
@@ -137,6 +172,9 @@ while getopts "cg:o:" opt; do | |||
137 | esac | 172 | esac |
138 | done | 173 | done |
139 | 174 | ||
175 | # maks sure that tar produces headers compatible with busybox format | ||
176 | # debian needs this | ||
177 | ogargs="$ogargs --format=oldgnu" | ||
140 | 178 | ||
141 | shift $(($OPTIND - 1)) | 179 | shift $(($OPTIND - 1)) |
142 | 180 | ||
@@ -171,6 +209,9 @@ if [ -z "$CONTROL" ]; then | |||
171 | exit 1 | 209 | exit 1 |
172 | fi | 210 | fi |
173 | 211 | ||
212 | # load values | ||
213 | collect_values | ||
214 | |||
174 | if ! pkg_appears_sane $pkg_dir; then | 215 | if ! pkg_appears_sane $pkg_dir; then |
175 | echo >&2 | 216 | echo >&2 |
176 | echo "ipkg-build: Please fix the above errors and try again." >&2 | 217 | echo "ipkg-build: Please fix the above errors and try again." >&2 |
diff --git a/scripts/mkipkg b/scripts/mkipkg index 43bd3a3..a336371 100755 --- a/scripts/mkipkg +++ b/scripts/mkipkg | |||
@@ -179,15 +179,15 @@ createFileList() | |||
179 | local includemaskpresent=0 | 179 | local includemaskpresent=0 |
180 | local excludemaskpresent=0 | 180 | local excludemaskpresent=0 |
181 | 181 | ||
182 | if (cat $1|grep -q ^FileExcludeMask); then | 182 | if (grep -q ^FileExcludeMask $1); then |
183 | excludemaskpresent=1 | 183 | excludemaskpresent=1 |
184 | excludeMask=$(eval echo '"'$(sed -n -e "s,^FileExcludeMask: *,,p" $1)'"') | 184 | excludeMask=$(eval echo '"'$(sed -n -e "s,^FileExcludeMask: *,,p" $1)'"') |
185 | fi | 185 | fi |
186 | if (cat $1|grep -q ^FileIncludeMask); then | 186 | if (grep -q ^FileIncludeMask $1); then |
187 | includemaskpresent=1 | 187 | includemaskpresent=1 |
188 | includeMask=$(eval echo '"'$(sed -n -e "s,^FileIncludeMask: *,,p" $1)'"') | 188 | includeMask=$(eval echo '"'$(sed -n -e "s,^FileIncludeMask: *,,p" $1)'"') |
189 | else | 189 | else |
190 | if (cat $1|grep -q ^Files:); then | 190 | if (grep -q ^Files: $1); then |
191 | includemaskpresent=1 | 191 | includemaskpresent=1 |
192 | includeMask=$(eval echo '"'$(sed -n -e "s,^Files: *,,p" $1)'"') | 192 | includeMask=$(eval echo '"'$(sed -n -e "s,^Files: *,,p" $1)'"') |
193 | fi | 193 | fi |
@@ -195,7 +195,9 @@ createFileList() | |||
195 | 195 | ||
196 | _pushd $destdir | 196 | _pushd $destdir |
197 | 197 | ||
198 | excludeMask="$excludeMask CONTROL/* usr/share/*" | 198 | declare -a excludeMaskArray |
199 | excludeMaskArray=( $excludeMask ) | ||
200 | excludeMaskArray=( "${excludeMaskArray[@]}" "CONTROL/*" "usr/share/*" ) | ||
199 | 201 | ||
200 | if [ $includemaskpresent != 1 ]; then | 202 | if [ $includemaskpresent != 1 ]; then |
201 | includeMask="." | 203 | includeMask="." |
@@ -209,21 +211,19 @@ createFileList() | |||
209 | 211 | ||
210 | expandMaskToList "$includeMask" _fileList | 212 | expandMaskToList "$includeMask" _fileList |
211 | 213 | ||
212 | _excludeList= | 214 | excludeMaskArray=( "${excludeMaskArray[@]}" "*/CVS*" "*/SCCS*" ) |
213 | if [ -n "$excludeMask" ]; then | ||
214 | expandMaskToList "$excludeMask" _excludeList | ||
215 | _excludeList="$_excludeList `find -name \*CVS\* -o -name \*SCCS\*`" | ||
216 | fi | ||
217 | 215 | ||
218 | local realFileList= | 216 | local realFileList= |
219 | local missing=0 | 217 | local missing=0 |
220 | for file in $_fileList; do | 218 | for file in $_fileList; do |
221 | local containedInList=0 | 219 | local containedInList=0 |
222 | for i in $_excludeList; do | 220 | for i in "${excludeMaskArray[@]}"; do |
223 | if [ $file = $i ]; then | 221 | if [[ $file == $i ]]; then |
224 | containedInList=1 | 222 | containedInList=1 |
223 | break; | ||
225 | fi | 224 | fi |
226 | done | 225 | done |
226 | |||
227 | if [ $containedInList = 0 ]; then | 227 | if [ $containedInList = 0 ]; then |
228 | if ! [ -e $file -o -L $file ]; then | 228 | if ! [ -e $file -o -L $file ]; then |
229 | echo "$self: $file not found" | 229 | echo "$self: $file not found" |
diff --git a/scripts/tothreaded b/scripts/tothreaded new file mode 100755 index 0000000..d9f8488 --- a/dev/null +++ b/scripts/tothreaded | |||
@@ -0,0 +1,132 @@ | |||
1 | #!/bin/sh | ||
2 | |||
3 | # PURPOSE : | ||
4 | # | ||
5 | # this script converts a non-threaded control file to a threaded one | ||
6 | # by extending appropriate names with -mt as extension | ||
7 | # | ||
8 | # eg abc.control becoms abc-mt.control | ||
9 | # | ||
10 | |||
11 | # | ||
12 | # make sure that the depends expression has enough spaces | ||
13 | # expression can contian : , ( ) || && | ||
14 | # | ||
15 | tokenize() { | ||
16 | sed "s/,/ & /g" | sed "s/)/ & /g" | sed "s/(/ & /g" | sed "s/|/ & /g" | sed "s/&/ & /g" | ||
17 | } | ||
18 | |||
19 | # | ||
20 | # function converts package name to threaded equivalend IF the | ||
21 | # package file HAS a threaded version | ||
22 | # | ||
23 | findthreadedequiv() { | ||
24 | local isin i | ||
25 | for i in $* | ||
26 | do | ||
27 | isin=`grep "^$i\$" "$ALLTHREADEDPKGSFILE"` | ||
28 | if [ -z "$isin" ] | ||
29 | then | ||
30 | # no threaded package | ||
31 | echo -n "$i " | ||
32 | else | ||
33 | # threaded package | ||
34 | echo -n "${isin}-mt " | ||
35 | fi | ||
36 | done | ||
37 | echo | ||
38 | } | ||
39 | |||
40 | # | ||
41 | # signature of binary files | ||
42 | # currently obsolete | ||
43 | # | ||
44 | # ISBINARY="*ELF*LSB*" | ||
45 | |||
46 | usage() { | ||
47 | echo "Usage : tothreaded <controlfile> <ALLPackages file>" | ||
48 | exit 2 | ||
49 | } | ||
50 | |||
51 | . scripts/SpecialMTFiles | ||
52 | |||
53 | # | ||
54 | # get the name of the controlfile to check for threading | ||
55 | # | ||
56 | if [ -z "$1" ] | ||
57 | then | ||
58 | usage | ||
59 | fi | ||
60 | controlfile=$1 | ||
61 | shift | ||
62 | |||
63 | case $controlfile in | ||
64 | *-mt.control) | ||
65 | #already threaded | ||
66 | echo $controlfile | ||
67 | exit 0; | ||
68 | ;; | ||
69 | esac | ||
70 | |||
71 | # | ||
72 | # file containing list of all known threaded packages | ||
73 | # | ||
74 | if [ -z "$1" ] | ||
75 | then | ||
76 | usage | ||
77 | fi | ||
78 | ALLTHREADEDPKGSFILE=$1 | ||
79 | shift | ||
80 | |||
81 | # | ||
82 | # strip out the name of the package | ||
83 | # | ||
84 | packagename=${controlfile##*/} # path | ||
85 | packagename=${packagename%.control} # extension | ||
86 | |||
87 | # | ||
88 | # generate new control file | ||
89 | # | ||
90 | newcontrolfile=${controlfile/\.control/-mt\.control} | ||
91 | |||
92 | # | ||
93 | # read all lines in original control file | ||
94 | # | ||
95 | while read line | ||
96 | do | ||
97 | case $line in | ||
98 | # convert some files to threaded equivalent | ||
99 | "Files:"*) | ||
100 | files=${line#Files:} | ||
101 | # thread-converted files | ||
102 | T_files=`ConvertSpecialFiles "$files"` | ||
103 | echo "Files: $T_files" | ||
104 | ;; | ||
105 | "Package: "*) | ||
106 | T_package=`findthreadedequiv ${line#Package: }` | ||
107 | echo "Package: ${T_package}" | ||
108 | ;; | ||
109 | "Depends: "*) | ||
110 | depends=`echo "${line#Depends: }" | tokenize` | ||
111 | T_depends=`findthreadedequiv ${depends}` | ||
112 | echo "Depends: $T_depends" | ||
113 | ;; | ||
114 | "Provides: "*) | ||
115 | T_provides=`findthreadedequiv ${line#Provides: }` | ||
116 | echo "Provides: $T_provides" | ||
117 | ;; | ||
118 | "Conflicts: "*) | ||
119 | conflicts=`echo "${line#Conflicts: }" | tokenize` | ||
120 | T_conflicts=`findthreadedequiv ${conflicts}` | ||
121 | echo "Conflicts: $T_conflicts" | ||
122 | ;; | ||
123 | *":"*) | ||
124 | echo "$line" | ||
125 | ;; | ||
126 | *) # al other lines | ||
127 | echo " $line" | ||
128 | ;; | ||
129 | esac | ||
130 | done < $controlfile > $newcontrolfile | ||
131 | |||
132 | echo $newcontrolfile | ||